<?php
require_once((defined("RHACO_DIR")?constant("RHACO_DIR"):"")."lang/Variable.php");
require_once((defined("RHACO_DIR")?constant("RHACO_DIR"):"")."util/Logger.php");
/**
 * @author kazutaka tokushima
 * @license New BSD License
 * @copyright Copyright 2006- The Rhacophorus Project. All rights reserved.
 */
class Automator{
	var $list = array();

	function Automator(){
	}
	function execute(){
		$variable	= "";
		$list		= array();

		if(Variable::isClassType(Automator,$this)){
			foreach(Variable::toArray($this->list) as $method){
				$list[] = $method;
			}
		}
		foreach(func_get_args() as $arg){
			foreach(Variable::toArray($arg) as $method){
				$list[] = $method;
			}
		}
		foreach($list as $method){
			list($class,$function) = split("::",$method);

			if(Rhaco::importLibrary($class)){
				$class	= preg_replace("/.+\.(.+)$/","\\1",$class);
				$object	= eval(sprintf("return new %s();",$class));

				foreach(get_class_methods($object) as $methodName){
					if($methodName == $function){
						Logger::debug($method);
						$variable = call_user_func_array(array(&$object,$function),array($variable));
						break;
					}
				}
			}
		}
		return $variable;
	}
	function add($method){
		$this->list[] = $method;
	}
}
?>